package org.processmining.plugins.cosa;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.models.graphbased.directed.petrinet.elements.ExpandableSubNet;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;

public class CosaSubflow extends CosaElement {

	private CosaScript script;

	public CosaSubflow() {
		script = null;
	}

	public void parse(CosaStream input, CosaScript parent, String path) throws FileNotFoundException, IOException {
		script = new CosaScript();
		String name = input.getToken();
		String separator = System.getProperty("file.separator");
		List<String> fileNames = new ArrayList<String>(Arrays.asList(name, name + ".scr", name.replaceAll("_", " "),
				name.replaceAll("_", " ") + ".scr"));
		InputStream stream = null;
		for (String fileName : fileNames) {
			if (stream == null) {
				try {
					stream = new FileInputStream(path + separator + fileName);
				} catch (FileNotFoundException ex) {
					// Ignore
				}
			}
		}
		if (stream != null) {
			script.parse(new CosaStream(stream), parent, path);
			input.advance();
		}
	}

	public void convertToNet(PetrinetGraph net, ExpandableSubNet subnet, Place startPlace, Place endPlace) {
		script.convertToNet(net, subnet, startPlace, endPlace);
	}
}
